pragma ComponentBehavior: Bound
import QtQuick
import QtQuick.Controls

Control {
    id: control

    property real dayWidth: 24
    property alias fromDate: model.fromDate
    property alias toDate: model.toDate

    contentItem: Row {
        Repeater {
            model: model

            delegate: Label {
                required property int dayCount
                required property string display

                elide: Text.ElideRight
                horizontalAlignment: Text.AlignHCenter
                text: display
                width: control.dayWidth * dayCount

                background: Rectangle {
                    border.color: "red"
                    border.width: 1
                    color: "lightgreen"
                }
            }
        }
    }

    TimelineMonthModel {
        id: model

    }
}
